All patches and comments are welcome. Please squash your changes to logical
commits before using git-format-patch and git-send-email to
patches@git.madduck.net.
If you'd read over the Git project's submission guidelines and adhered to them,
I'd be especially grateful.
7 mr - a Multiple Repository management tool
11 B<mr> [options] checkout
13 B<mr> [options] update
15 B<mr> [options] status
17 B<mr> [options] commit [-m "message"]
23 B<mr> [options] register [repository]
25 B<mr> [options] config section ["parameter=[value]" ...]
27 B<mr> [options] action [params ...]
31 B<mr> is a Multiple Repository management tool. It can checkout, update, or
32 perform other actions on a set of repositories as if they were one combined
33 respository. It supports any combination of subversion, git, cvs, mecurial and
34 bzr repositories, and support for other revision control systems can easily be
37 B<mr> cds into and operates on all registered repositories at or below your
38 working directory. Or, if you are in a subdirectory of a repository that
39 contains no other registered repositories, it will stay in that directory,
40 and work on only that repository,
42 These predefined commands should be fairly familiar to users of any revision
47 =item checkout (or co)
49 Checks out any repositories that are not already checked out.
53 Updates each repository from its configured remote repository.
55 If a repository isn't checked out yet, it will first check it out.
59 Displays a status report for each repository, showing what
60 uncommitted changes are present in the repository.
64 Commits changes to each repository. (By default, changes are pushed to the
65 remote repository too, when using distributed systems like git.)
67 The optional -m parameter allows specifying a commit message.
71 Show a diff of uncommitted changes.
79 These commands are also available:
85 List the repositories that mr will act on.
89 Register an existing repository in a mrconfig file. By default, the
90 repository in the current directory is registered, or you can specify a
91 directory to register.
93 The mrconfig file that is modified is chosen by either the -c option, or by
94 looking for the closest known one at or below the current directory.
98 Adds, modifies, removes, or prints a value from a mrconfig file. The next
99 parameter is the name of the section the value is in. To add or modify
100 values, use one or more instances of "parameter=value". Use "parameter=" to
101 remove a parameter. Use just "parameter" to get the value of a parameter.
103 For example, to add (or edit) a repository in src/foo:
105 mr config src/foo checkout="svn co svn://example.com/foo/trunk foo"
107 To show the command that mr uses to update the repository in src/foo:
109 mr config src/foo update
111 To see the built-in library of shell functions contained in mr:
113 mr config DEFAULT lib
115 The ~/.mrconfig file is used by default. To use a different config file,
124 Actions can be abbreviated to any unambiguous subsctring, so
125 "mr st" is equivilant to "mr status", and "mr up" is equivilant to "mr
128 Additional parameters can be passed to most commands, and are passed on
129 unchanged to the underlying revision control system. This is mostly useful
130 if the repositories mr will act on all use the same revision control
139 Specifies the topmost directory that B<mr> should work in. The default is
140 the current working directory.
144 Use the specified mrconfig file. The default is B<~/.mrconfig>
152 Expand the statistics line displayed at the end to include information
153 about exactly which repositories failed and were skipped, if any.
157 Just operate on the repository for the current directory, do not
158 recurse into deeper repositories.
162 Run the specified number of jobs in parallel. This can greatly speed up
163 operations such as updates. It is not recommended for interactive
170 B<mr> is configured by .mrconfig files. It starts by reading the .mrconfig
171 file in your home directory, and this can in turn chain load .mrconfig files
174 Here is an example .mrconfig file:
177 checkout = svn co svn://svn.example.com/src/trunk src
181 checkout = git clone git://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux-2.6.git &&
183 git checkout -b mybranch origin/master
185 The .mrconfig file uses a variant of the INI file format. Lines starting with
186 "#" are comments. Values can be continued to the following line by
187 indenting the line with whitespace.
189 The "DEFAULT" section allows setting default values for the sections that
192 The "ALIAS" section allows adding aliases for actions. Each parameter
193 is an alias, and its value is the action to use.
195 All other sections add repositories. The section header specifies the
196 directory where the repository is located. This is relative to the directory
197 that contains the mrconfig file, but you can also choose to use absolute
200 Within a section, each parameter defines a shell command to run to handle a
201 given action. mr contains default handlers for "update", "status",
202 "commit", and other standard actions. Normally you only need to specify what
203 to do for "checkout".
205 Note that these shell commands are run in a "set -e" shell
206 environment, where any additional parameters you pass are available in
207 "$@". The "checkout" command is run in the parent of the repository
208 directory, since the repository isn't checked out yet. All other commands
209 are run inside the repository, though not necessarily at the top of it.
211 The "MR_REPO" environment variable is set to the path to the top of the
212 repository. The "MR_CONFIG" environment variable is set to the .mrconfig file
213 that defines the repo being acted on, or, if the repo is not yet in a config
214 file, the .mrconfig file that should be modified to register the repo.
216 A few parameters have special meanings:
222 If the "skip" parameter is set and its command returns true, then B<mr>
223 will skip acting on that repository. The command is passed the action
226 Here are two examples. The first skips the repo unless
227 mr is run by joey. The second uses the hours_since function
228 (included in mr's built-in library) to skip updating the repo unless it's
229 been at least 12 hours since the last update.
231 skip = test $(whoami) != joey
232 skip = [ "$1" = update ] && [ $(hours_since "$1") -lt 12 ]
236 If the "chain" parameter is set and its command returns true, then B<mr>
237 will try to load a .mrconfig file from the root of the repository. (You
238 should avoid chaining from repositories with untrusted committers.)
242 The "lib" parameter can specify some shell code that will be run before each
243 command, this can be a useful way to define shell functions for other commands
250 Copyright 2007 Joey Hess <joey@kitenet.net>
252 Licensed under the GNU GPL version 2 or higher.
254 http://kitenet.net/~joey/code/mr/
263 use Cwd qw(getcwd abs_path);
273 print STDERR "mr: interrupted\n";
277 $ENV{MR_CONFIG}="$ENV{HOME}/.mrconfig";
278 my $config_overridden=0;
279 my $directory=getcwd();
289 Getopt::Long::Configure("no_permute");
290 my $result=GetOptions(
291 "d|directory=s" => sub { $directory=abs_path($_[1]) },
292 "c|config=s" => sub { $ENV{MR_CONFIG}=$_[1]; $config_overridden=1 },
293 "v|verbose" => \$verbose,
294 "s|stats" => \$stats,
295 "n|no-recurse" => \$no_recurse,
296 "j|jobs=i" => \$jobs,
298 if (! $result || @ARGV < 1) {
299 die("Usage: mr [-d directory] action [params ...]\n".
300 "(Use mr help for man page.)\n");
304 # Make sure MR_CONFIG is an absolute path, but don't use abs_path since
305 # the config file might be a symlink to elsewhere, and the directory it's
307 if ($ENV{MR_CONFIG} !~ /^\//) {
308 $ENV{MR_CONFIG}=getcwd()."/".$ENV{MR_CONFIG};
310 # Try to set MR_PATH to the path to the program.
312 use FindBin qw($Bin $Script);
313 $ENV{MR_PATH}=$Bin."/".$Script;
317 loadconfig($ENV{MR_CONFIG});
319 #print Dumper(\%config);
321 # alias expansion and command stemming
322 my $action=shift @ARGV;
323 if (exists $alias{$action}) {
324 $action=$alias{$action};
326 if (! exists $knownactions{$action}) {
327 my @matches = grep { /^\Q$action\E/ }
328 keys %knownactions, keys %alias;
332 elsif (@matches == 0) {
333 die "mr: unknown action \"$action\" (known actions: ".
334 join(", ", sort keys %knownactions).")\n";
337 die "mr: ambiguous action \"$action\" (matches: ".
338 join(", ", @matches).")\n";
342 # commands that do not operate on all repos
343 if ($action eq 'help') {
344 exec($config{''}{DEFAULT}{$action}) || die "exec: $!";
346 elsif ($action eq 'config') {
348 die "mr config: not enough parameters\n";
351 if ($section=~/^\//) {
352 # try to convert to a path relative to the config file
353 my ($dir)=$ENV{MR_CONFIG}=~/^(.*\/)[^\/]+$/;
355 $dir.="/" unless $dir=~/\/$/;
356 if ($section=~/^\Q$dir\E(.*)/) {
362 if (/^([^=]+)=(.*)$/) {
363 $changefields{$1}=$2;
367 foreach my $topdir (sort keys %config) {
368 if (exists $config{$topdir}{$section} &&
369 exists $config{$topdir}{$section}{$_}) {
370 print $config{$topdir}{$section}{$_}."\n";
372 last if $section eq 'DEFAULT';
376 die "mr $action: $section $_ not set\n";
380 modifyconfig($ENV{MR_CONFIG}, $section, %changefields) if %changefields;
383 elsif ($action eq 'register') {
384 if (! $config_overridden) {
385 # Find the closest known mrconfig file to the current
387 $directory.="/" unless $directory=~/\/$/;
388 foreach my $topdir (reverse sort keys %config) {
389 next unless length $topdir;
390 if ($directory=~/^\Q$topdir\E/) {
391 $ENV{MR_CONFIG}=$configfiles{$topdir};
396 my $command="set -e; ".$config{''}{DEFAULT}{lib}."\n".
397 "my_action(){ $config{''}{DEFAULT}{$action}\n }; my_action ".
398 join(" ", map { s/\//\/\//g; s/"/\"/g; '"'.$_.'"' } @ARGV);
399 print STDERR "mr $action: running >>$command<<\n" if $verbose;
400 exec($command) || die "exec: $!";
403 # work out what repos to act on
406 foreach my $topdir (sort keys %config) {
407 foreach my $subdir (sort keys %{$config{$topdir}}) {
408 next if $subdir eq 'DEFAULT';
409 my $dir=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
411 $dir.="/" unless $dir=~/\/$/;
412 $d.="/" unless $d=~/\/$/;
413 next if $no_recurse && $d ne $dir;
414 next if $dir ne $d && $dir !~ /^\Q$d\E/;
415 push @repos, [$dir, $topdir, $subdir];
419 # fallback to find a leaf repo
420 LEAF: foreach my $topdir (reverse sort keys %config) {
421 foreach my $subdir (reverse sort keys %{$config{$topdir}}) {
422 next if $subdir eq 'DEFAULT';
423 my $dir=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
425 $dir.="/" unless $dir=~/\/$/;
426 $d.="/" unless $d=~/\/$/;
427 if ($d=~/^\Q$dir\E/) {
428 push @repos, [$dir, $topdir, $subdir];
436 # run the action on each repository and print stats
437 my (@ok, @failed, @skipped);
442 foreach my $repo (@repos) {
443 record($repo, action($action, @$repo));
447 if (! @ok && ! @failed && ! @skipped) {
448 die "mr $action: no repositories found to work on\n";
450 print "mr $action: finished (".join("; ",
451 showstat($#ok+1, "ok", "ok"),
452 showstat($#failed+1, "failed", "failed"),
453 showstat($#skipped+1, "skipped", "skipped"),
457 print "mr $action: (skipped: ".join(" ", @skipped).")\n";
460 print STDERR "mr $action: (failed: ".join(" ", @failed).")\n";
466 elsif (! @ok && @skipped) {
472 my ($action, $dir, $topdir, $subdir) = @_;
474 $ENV{MR_CONFIG}=$configfiles{$topdir};
475 my $lib=exists $config{$topdir}{$subdir}{lib} ?
476 $config{$topdir}{$subdir}{lib}."\n" : "";
478 if ($action eq 'checkout') {
480 print "mr $action: $dir already exists, skipping checkout\n" if $verbose;
484 $dir=~s/^(.*)\/[^\/]+\/?$/$1/;
487 print "mr $action: creating parent directory $dir\n" if $verbose;
488 system("mkdir", "-p", $dir);
491 elsif ($action eq 'update') {
493 return action("checkout", $dir, $topdir, $subdir);
499 if (exists $config{$topdir}{$subdir}{skip}) {
500 my $test="set -e;".$lib.
501 "my_action(){ $config{$topdir}{$subdir}{skip}\n }; my_action '$action'";
502 print "mr $action: running skip test >>$test<<\n" if $verbose;
503 my $ret=system($test);
505 if (($? & 127) == 2) {
506 print STDERR "mr $action: interrupted\n";
510 print STDERR "mr $action: skip test received signal ".($? & 127)."\n";
514 if ($ret >> 8 == 0) {
515 print "mr $action: $dir skipped per config file\n" if $verbose;
520 if (! $nochdir && ! chdir($dir)) {
521 print STDERR "mr $action: failed to chdir to $dir: $!\n";
524 elsif (! exists $config{$topdir}{$subdir}{$action}) {
525 print STDERR "mr $action: no defined $action command for $topdir$subdir, skipping\n";
530 print "mr $action: $topdir$subdir\n";
533 print "mr $action: $topdir$subdir (in subdir $directory)\n";
535 my $command="set -e; ".$lib.
536 "my_action(){ $config{$topdir}{$subdir}{$action}\n }; my_action ".
537 join(" ", map { s/\//\/\//g; s/"/\"/g; '"'.$_.'"' } @ARGV);
538 print STDERR "mr $action: running >>$command<<\n" if $verbose;
539 my $ret=system($command);
541 if (($? & 127) == 2) {
542 print STDERR "mr $action: interrupted\n";
546 print STDERR "mr $action: received signal ".($? & 127)."\n";
549 print STDERR "mr $action: failed ($ret)\n" if $verbose;
550 if ($ret >> 8 != 0) {
551 print STDERR "mr $action: command failed\n";
554 print STDERR "mr $action: command died ($ret)\n";
559 if ($action eq 'checkout' && ! -d $dir) {
560 print STDERR "mr $action: $dir missing after checkout\n";;
569 # run actions on multiple repos, in parallel
576 while (@fhs or @repos) {
577 while ($running < $jobs && @repos) {
579 my $repo = shift @repos;
580 pipe(my $outfh, CHILD_STDOUT);
581 pipe(my $errfh, CHILD_STDERR);
582 unless (my $pid = fork) {
583 die "cannot fork: $!" unless defined $pid;
584 open(STDOUT, ">&CHILD_STDOUT") || die "reopen stdout: $!";
585 open(STDERR, ">&CHILD_STDERR") || die "reopen stderr: $!";
590 exit action($action, @$repo);
595 push @fhs, [$outfh, $errfh];
598 my ($rin, $rout) = ('','');
600 foreach my $fh (@fhs) {
601 next unless defined $fh;
602 vec($rin, fileno($fh->[0]), 1) = 1 if defined $fh->[0];
603 vec($rin, fileno($fh->[1]), 1) = 1 if defined $fh->[1];
605 $nfound = select($rout=$rin, undef, undef, 1);
606 foreach my $channel (0, 1) {
607 foreach my $i (0..$#fhs) {
608 next unless defined $fhs[$i];
609 my $fh = $fhs[$i][$channel];
610 next unless defined $fh;
611 if (vec($rout, fileno($fh), 1) == 1) {
613 if (sysread($fh, $r, 1024) == 0) {
615 $fhs[$i][$channel] = undef;
616 if (! defined $fhs[$i][0] &&
617 ! defined $fhs[$i][1]) {
618 print STDOUT $out[$i][0];
619 print STDERR $out[$i][1];
621 record($active[$i], $? >> 8);
623 splice(@active, $i, 1);
628 $out[$i][$channel] .= $r;
636 my $dir=shift()->[0];
642 elsif ($ret == FAILED) {
645 elsif ($ret == SKIPPED) {
648 elsif ($ret == ABORT) {
652 die "unknown exit status $ret";
661 return "$count ".($count > 1 ? $plural : $singular);
667 sub loadconfig { #{{{
674 if (ref $f eq 'GLOB') {
683 my $absf=abs_path($f);
684 if ($loaded{$absf}) {
689 ($dir)=$f=~/^(.*\/)[^\/]+$/;
690 if (! defined $dir) {
693 $dir=abs_path($dir)."/";
695 if (! exists $configfiles{$dir}) {
696 $configfiles{$dir}=$f;
699 # copy in defaults from first parent
701 while ($parent=~s/^(.*\/)[^\/]+\/?$/$1/) {
702 if ($parent eq '/') {
705 if (exists $config{$parent} &&
706 exists $config{$parent}{DEFAULT}) {
707 $config{$dir}{DEFAULT}={ %{$config{$parent}{DEFAULT}} };
712 print "mr: loading config $f\n" if $verbose;
713 open($in, "<", $f) || die "mr: open $f: $!\n";
724 next if /^\s*\#/ || /^\s*$/;
725 if (/^\[([^\]]*)\]\s*$/) {
728 elsif (/^(\w+)\s*=\s*(.*)/) {
733 while (@lines && $lines[0]=~/^\s(.+)/) {
740 if (! defined $section) {
741 die "$f line $.: parameter ($parameter) not in section\n";
743 if ($section ne 'ALIAS' &&
744 ! exists $config{$dir}{$section} &&
745 exists $config{$dir}{DEFAULT}) {
747 $config{$dir}{$section}={ %{$config{$dir}{DEFAULT}} };
749 if ($section eq 'ALIAS') {
750 $alias{$parameter}=$value;
752 elsif ($parameter eq 'lib') {
753 $config{$dir}{$section}{lib}.=$value."\n";
756 $config{$dir}{$section}{$parameter}=$value;
757 $knownactions{$parameter}=1;
758 if ($parameter eq 'chain' &&
759 length $dir && $section ne "DEFAULT" &&
760 -e $dir.$section."/.mrconfig") {
761 my $ret=system($value);
763 if (($? & 127) == 2) {
764 print STDERR "mr $action: chain test interrupted\n";
768 print STDERR "mr $action: chain test received signal ".($? & 127)."\n";
772 push @toload, $dir.$section."/.mrconfig";
778 die "$f line $line: parse error\n";
787 sub modifyconfig { #{{{
789 # the section to modify or add
790 my $targetsection=shift;
791 # fields to change in the section
792 # To remove a field, set its value to "".
799 open(my $in, "<", $f) || die "mr: open $f: $!\n";
804 my $formatfield=sub {
806 my @value=split(/\n/, shift);
808 return "$field = ".shift(@value)."\n".
809 join("", map { "\t$_\n" } @value);
813 while ($out[$#out] =~ /^\s*$/) {
814 unshift @blanks, pop @out;
816 foreach my $field (sort keys %changefields) {
817 if (length $changefields{$field}) {
818 push @out, "$field = $changefields{$field}\n";
819 delete $changefields{$field};
829 if (/^\s*\#/ || /^\s*$/) {
832 elsif (/^\[([^\]]*)\]\s*$/) {
833 if (defined $section &&
834 $section eq $targetsection) {
842 elsif (/^(\w+)\s*=\s(.*)/) {
847 while (@lines && $lines[0]=~/^\s(.+)/) {
853 if ($section eq $targetsection) {
854 if (exists $changefields{$parameter}) {
855 if (length $changefields{$parameter}) {
856 $value=$changefields{$parameter};
858 delete $changefields{$parameter};
862 push @out, $formatfield->($parameter, $value);
866 if (defined $section &&
867 $section eq $targetsection) {
870 elsif (%changefields) {
871 push @out, "\n[$targetsection]\n";
872 foreach my $field (sort keys %changefields) {
873 if (length $changefields{$field}) {
874 push @out, $formatfield->($field, $changefields{$field});
879 open(my $out, ">", $f) || die "mr: write $f: $!\n";
884 # Finally, some useful actions that mr knows about by default.
885 # These can be overridden in ~/.mrconfig.
900 for dir in .git .svn .bzr CVS .hg; do
901 if [ -e "$MR_REPO/$dir" ]; then
902 flagfile="$MR_REPO/$dir/.mr_last$1"
906 if [ -z "$flagfile" ]; then
907 error "cannot determine flag filename"
909 perl -wle 'print -f shift() ? int((-M _) * 24) : 9999' "$flagfile"
914 if [ -d "$MR_REPO"/.svn ]; then
916 elif [ -d "$MR_REPO"/.git ]; then
918 git pull -t origin master
922 elif [ -d "$MR_REPO"/.bzr ]; then
924 elif [ -d "$MR_REPO"/CVS ]; then
926 elif [ -d "$MR_REPO"/.hg ]; then
927 hg pull "$@" && hg update "$@"
929 error "unknown repo type"
932 if [ -d "$MR_REPO"/.svn ]; then
934 elif [ -d "$MR_REPO"/.git ]; then
935 git status "$@" || true
936 elif [ -d "$MR_REPO"/.bzr ]; then
938 elif [ -d "$MR_REPO"/CVS ]; then
940 elif [ -d "$MR_REPO"/.hg ]; then
943 error "unknown repo type"
946 if [ -d "$MR_REPO"/.svn ]; then
948 elif [ -d "$MR_REPO"/.git ]; then
949 git commit -a "$@" && git push --all
950 elif [ -d "$MR_REPO"/.bzr ]; then
951 bzr commit "$@" && bzr push
952 elif [ -d "$MR_REPO"/CVS ]; then
954 elif [ -d "$MR_REPO"/.hg ]; then
955 hg commit -m "$@" && hg push
957 error "unknown repo type"
960 if [ -d "$MR_REPO"/.svn ]; then
962 elif [ -d "$MR_REPO"/.git ]; then
964 elif [ -d "$MR_REPO"/.bzr ]; then
966 elif [ -d "$MR_REPO"/CVS ]; then
968 elif [ -d "$MR_REPO"/.hg ]; then
971 error "unknown repo type"
974 if [ -d "$MR_REPO"/.svn ]; then
976 elif [ -d "$MR_REPO"/.git ]; then
978 elif [ -d "$MR_REPO"/.bzr ]; then
980 elif [ -d "$MR_REPO"/CVS ]; then
982 elif [ -d "$MR_REPO"/.hg ]; then
985 error "unknown repo type"
991 basedir="$(basename $(pwd))"
993 url=$(LANG=C svn info . | grep -i ^URL: | cut -d ' ' -f 2)
994 if [ -z "$url" ]; then
995 error "cannot determine svn url"
997 echo "Registering svn url: $url in $MR_CONFIG"
998 mr -c "$MR_CONFIG" config "$(pwd)" checkout="svn co $url $basedir"
999 elif [ -d .git ]; then
1000 url=$(LANG=C git-config --get remote.origin.url)
1001 if [ -z "$url" ]; then
1002 error "cannot determine git url"
1004 echo "Registering git url: $url in $MR_CONFIG"
1005 mr -c "$MR_CONFIG" config "$(pwd)" checkout="git clone $url $basedir"
1006 elif [ -d .bzr ]; then
1007 url=$(cat .bzr/branch/parent)
1008 if [ -z "$url" ]; then
1009 error "cannot determine bzr url"
1011 echo "Registering bzr url: $url in $MR_CONFIG"
1012 mr -c "$MR_CONFIG" config "$(pwd)" checkout="bzr clone $url $basedir"
1013 elif [ -d CVS ]; then
1014 repo=$(cat CVS/Repository)
1015 root=$(cat CVS/Root)
1016 if [ -z "$root" ]; then
1017 error "cannot determine cvs root"
1019 echo "Registering cvs repository $repo at root $root"
1020 mr -c "$MR_CONFIG" config "$(pwd)" \
1021 checkout="cvs -d '$root' co -d $basedir $repo"
1022 elif [ -d .hg ]; then
1023 url=$(hg showconfig paths.default)
1024 echo "Registering mercurial repo url: $url in $MR_CONFIG"
1025 mr -c "$MR_CONFIG" config "$(pwd)" \
1026 checkout="hg clone $url $basedir"
1028 error "unable to register this repo type"
1031 if [ ! -e "$MR_PATH" ]; then
1032 error "cannot find program path"
1034 (pod2man -c mr "$MR_PATH" | man -l -) || error "pod2man or man failed"
1038 ed = echo "A horse is a horse, of course, of course.."
1039 T = echo "I pity the fool."
1040 right = echo "Not found."